Subject: Re: [PATCH] usage.[ch] API users: use report_fn, not hardcoded prototype

From: Taylor Blau <[email-masked]>
Date: Mon, 21 Feb 2022 13:21:12 -0500

On Mon, Feb 21, 2022 at 05:09:18PM +0100, Ævar Arnfjörð Bjarmason wrote:
> Change a couple of users of "report_fn" that hardcoded a definition of
> it to use the definition of report_fn instead.
>
> Signed-off-by: Ævar Arnfjörð Bjarmason <[email-masked]>
> ---
>
> I'll eventually want to depend on this for a larger topic I plan to
> re-roll[1], but in the meantime this trivial fix can hopefully cook &
> graduate.

This looks good to me, thanks.

> diff --git a/run-command.c b/run-command.c
> index a8501e38ceb..3d854c498aa 100644
> --- a/run-command.c
> +++ b/run-command.c
> @@ -362,10 +362,9 @@ static void NORETURN child_die_fn(const char *err, va_list params)
>  /* this runs in the parent process */
>  static void child_err_spew(struct child_process *cmd, struct child_err *cerr)
>  {
> -	static void (*old_errfn)(const char *err, va_list params);
> +	report_fn old_errfn = get_error_routine();
>  	report_fn die_message_routine = get_die_message_routine();

Perhaps as part of the larger series you alluded to earlier, but we
could get rid of the die_message_routine variable here altogether. It
only exists to pass as the argument to set_error_routine(), and isn't
used anywhere else in the function.

So you could do something like this on top:

--- >8 ---
diff --git a/run-command.c b/run-command.c
index 3d854c498a..4afa01db9a 100644
--- a/run-command.c
+++ b/run-command.c
@@ -363,9 +363,8 @@ static void NORETURN child_die_fn(const char *err, va_list params)
 static void child_err_spew(struct child_process *cmd, struct child_err *cerr)
 {
 	report_fn old_errfn = get_error_routine();
-	report_fn die_message_routine = get_die_message_routine();

-	set_error_routine(die_message_routine);
+	set_error_routine(get_die_message_routine());
 	errno = cerr->syserr;

 	switch (cerr->err) {
--- 8< ---

But it doesn't need to happen here, just an idle thought I had while
reading.

Thanks,
Taylor